
package Transformation.Hough;
import java.awt.Image;
import java.awt.Toolkit;

import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;

/**
 * Klasse wird zum Aufruf der Funktionen der Klasse EdgeDetector
 * bentigt. Trennung um die Klasse EdgeDetection ( nicht aus unserer
 * Feder ) nicht verndern und unserem Interface anpassen zu mssen.
 */
public class BerechnungBildFilter implements IBildBearbeitung  {

	private Image filterBild=null;
	private Image newImg = null;
	
	//Ausgabebild Hhe und Breite
	private int d_w;
	private int d_h;

	private int[] dest_1d;
	
	
	/**
	 * @param Image - swBild
	 */
	public BerechnungBildFilter(Image swBild){
		this.filterBild=swBild;
		bildFiltern();
	}
	

	/**
	 * Wird von unserer GUI aufgerufen. Gibt das berechnete/gefilterte
	 * Bild zurck.
	 * @return Image - gefiltertes Bild
	 */
	public Image getCalculatedImage() {		
		return newImg;
	}
	
	/**
	 * fhrt die Methoden der Klasse EdgeDetector aus, damit
	 * das Bild gefiltert wird. Das Ergebnis ist ein Bild
	 * wo die Kantenbergnge extra hervorgehoben wurden.
	 *
	 */
	private void bildFiltern(){	
		
		EdgeDetector edge = new EdgeDetector();
		
		edge.setSourceImage(filterBild);
		
		try
		{
		  edge.process();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		
		int width=filterBild.getWidth(new MyImageObserver());
		int height=filterBild.getHeight(new MyImageObserver());		
	    
		int[] pix = new int[width * height];

		try 
		{
			PixelGrabber pg = new PixelGrabber( edge.getEdgeImage(), 0, 0, width, height,pix, 0, width );
			pg.grabPixels();
			
			for(int yx=0;yx<(width*height);yx++)
			{
				int value=(pix[yx] & 0x00FFFFFF);
				value=16777215-value;
			    pix[yx]=(0xFF000000 | value);
			}
		}
		catch( InterruptedException e ) 
		{
			System.out.println("Error.");
		}
		
		
		newImg = Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(width, height, pix, 0, width) );

		
	}

	/**
	 * Methode hat in dieser Klasse keine besondere Bedeutung.
	 * Gibt einfach das Originalbild zurck.
	 * Mehr zur Funktion in BerechnungHoughRaum. @see BerechnungHoughRaum#getMoreContrast(Image, int, int)
	 */
	public Image getMoreContrast(Image source,int width,int height) {
		
		return source;
	}
	
}
