
package Transformation.Hough;
import java.awt.event.KeyEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;
import java.awt.image.MemoryImageSource;
import java.awt.image.PixelGrabber;
import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Component;
import java.awt.Event;
import java.awt.FlowLayout;
import java.awt.HeadlessException;
import java.awt.Image;
import java.awt.Toolkit;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.JPanel;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JCheckBox;
import javax.swing.JButton;
import javax.swing.SwingUtilities;
import javax.swing.Timer;
import javax.swing.UIManager;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;

import javax.swing.BoxLayout;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.JSlider;

import com.sun.org.apache.bcel.internal.generic.INSTANCEOF;

/**
 * Das ist die GUI, enthllt auch die Test-Methoden sowie die Main
 */
public class HoughTransformationGUI extends JFrame  implements ActionListener , ChangeListener {

	private JFrame fensterl = new JFrame();
	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JMenuBar jJMenuBar = null;
	
	private JPanel menuePanel = null;
	private JMenu fileMenu = null;
	private JMenu editMenu = null;
	private JMenu helpMenu = null;
	private JMenuItem exitMenuItem = null;
	private JMenuItem aboutMenuItem = null;
	private JMenuItem nextMenuItem = null;
	private JMenuItem openMenuItem = null;
	private JPanel bildanzeigePanel = null;
	
	private JPanel filterBildPanel = null;
	private JCheckBox filterBildCheckBox = null;
	private JButton filterBildButton = null;
	private ImageComponent filterBildComponent = null;
	private JPanel filterBildCard = null;
	
	private JPanel houghBildPanel = null;
	private JPanel houghBildCard = null;
	private JCheckBox houghBildCheckBox = null;
	private JButton houghBildButton = null;
	private ImageComponent houghBildComponent = null;
	
	private JPanel orgBildPanel = null;
	private JPanel orgBildCard = null;	
	private JCheckBox orgBildCheckBox = null;
	private JButton orgBildButton = null;
	private ImageComponent orgBildComponent = null;	
	
	private JPanel houghRaumBildCard = null;
	private JPanel houghRaumBildPanel = null;
	private JCheckBox houghRaumBildCheckBox = null;
	private JButton houghRaumBildButton = null;
	private ImageComponent houghRaumComponent = null;
	
	private Image[] alleBilder = new Image[4]; //hier sind alle Image - Objekte 
		
	private CardLayout kartenLayout = null;

	//Kartenkonstanten
	final static String ORIGINALBILD = "orgBild";
	final static String HRBILD = "hrBild";
	final static String FILTERBILD = "filterBild";
	final static String HOUGHBILD = "houghBild";

	//slider konstatnten
	final static int SLIDER_MIN = 0; // 0 min
	final static int SLIDER_MAX = 100; //1 max
	final static int SLIDER_INIT =100; 
	
	// Schwellwert fr HoughBerechnung
	double schwellWert = 1;
	
	private JFileChooser dateiAuswahl = null;
	private JMenuItem houghMenuItem = null;
	
	private JPanel sliderPanel = null;
	private JSlider schwellWertSlider = null;
	private JLabel schwellWertLabel = null;
	private JLabel schwellWertAnzeigeLabel = null;
	
	
	private long houghRaumPower=0;
	private long houghPower=0;
	private long powerGesamt=0;
	private JMenu testMenu = null;
	private JMenuItem wertErstellung = null;
	private JMenu auswertungMenu = null;
	private JMenuItem houghRauMenuItem = null;
	private JMenuItem houghTransformMenuItem = null;
	private JMenuItem ratioTestHoughMenuItem = null;
	private JMenuItem ratioHoughRaumMenuItem = null;
	private JMenuItem ratioGesMenuItem = null;	
	//private String pfad="hough/Transformation/";
	private String pfad="Transformation/";
	
	/**
	 * This method initializes bildanzeigePanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getBildanzeigePanel() {
		if (bildanzeigePanel == null) {
			bildanzeigePanel = new JPanel(new CardLayout());
		}
		return bildanzeigePanel;
	}

	/**
	 * This method initializes menuePanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getMenuePanel() {
		if (menuePanel == null) {
			menuePanel = new JPanel();
			menuePanel.add(getOrgBildPanel(), null);
			menuePanel.add(getFilterBildPanel(), null);
			menuePanel.add(getHoughRaumBildPanel(), null);
			menuePanel.add(getHoughBildPanel(), null);		
			menuePanel.setVisible(false);
		}
		return menuePanel;
	}


	/**
	 * This method initializes houghBildCard	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getHoughBildCard() {
		if (houghBildCard == null) {
			houghBildCard = new JPanel();
		}
		return houghBildCard;
	}

	/**
	 * This method initializes houghbildPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getHoughBildPanel() {
		if (houghBildPanel == null) {
			houghBildPanel = new JPanel();
			houghBildPanel.add(getHoughBildCheckBox(), null);
			houghBildPanel.add(getHoughBildButton(), null);
		}
		return houghBildPanel;
	}
	

	/**
	 * This method initializes houghBildCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getHoughBildCheckBox() {
		if (houghBildCheckBox == null) {
			houghBildCheckBox = new JCheckBox();
			houghBildCheckBox.setSelected(false);
			houghBildCheckBox.setEnabled(false);
		}
		return houghBildCheckBox;
	}

	/**
	 * This method initializes houghBildButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getHoughBildButton() {
		if (houghBildButton == null) {
			houghBildButton = new JButton();
			houghBildButton.setText("Hough - Bild");
			houghBildButton.setEnabled(false);
			houghBildButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if(orgBildButton.isEnabled()==true){

						setSliderVisbility(true);
						System.out.println("hough bild anzeigen");//FIXME debug
						kartenLayout.show(bildanzeigePanel, HOUGHBILD);
						
						houghBildButton.setEnabled(false);
						filterBildButton.setEnabled(true);
						orgBildButton.setEnabled(true);
						houghRaumBildButton.setEnabled(true);
						
						pack();
					}
				}
			});
		}
		return houghBildButton;
	}


	
	/**
	 * This method initializes orgBildPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getOrgBildPanel() {
		if (orgBildPanel == null) {
			orgBildPanel = new JPanel();
			orgBildPanel.add(getOrgBildCheckBox(), null);
			orgBildPanel.add(getOrgBildButton(), null);
		}
		return orgBildPanel;
	}

	/**
	 * This method initializes orgBildCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getOrgBildCheckBox() {
		if (orgBildCheckBox == null) {
			orgBildCheckBox = new JCheckBox();
			orgBildCheckBox.setSelected(false);
			orgBildCheckBox.setEnabled(false);
		}
		return orgBildCheckBox;
	}

	/**
	 * This method initializes orgBildButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getOrgBildButton() {
		if (orgBildButton == null) {
			orgBildButton = new JButton();
			orgBildButton.setText("orgnial Bild");
			orgBildButton.setEnabled(false);		
			orgBildButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if(orgBildButton.isEnabled()==true){
						setSliderVisbility(false);
						System.out.println("org Bild anzeigen");//FIXME debug
						kartenLayout.show(bildanzeigePanel, ORIGINALBILD);
						orgBildButton.setEnabled(false);
						filterBildButton.setEnabled(true);
						
						if(houghRaumBildCheckBox.isSelected()==true){
							houghRaumBildButton.setEnabled(true);
						}
						if(houghBildCheckBox.isSelected()==true){
							houghBildButton.setEnabled(true);
						}
					}										
				}
			});
		}
		return orgBildButton;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getOrgBildCard() {
		if (orgBildCard == null) {
			orgBildCard = new JPanel();
		}
		return orgBildCard;
	}
	

	/**
	 * This method initializes swBildPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getFilterBildPanel() {
		if (filterBildPanel == null) {
			filterBildPanel = new JPanel();
			filterBildPanel.add(getFilterBildCheckBox(), null);
			filterBildPanel.add(getFilterBildButton(), null);
		}
		return filterBildPanel;
	}

	
	/**
	 * This method initializes swBildCard	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getFilterBildCard() {
		if (filterBildCard == null) {
			filterBildCard = new JPanel();
		}
		return filterBildCard;
	}

	/**
	 * This method initializes swBildCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getFilterBildCheckBox() {
		if (filterBildCheckBox == null) {
			filterBildCheckBox = new JCheckBox();
			filterBildCheckBox.setSelected(false);
			filterBildCheckBox.setEnabled(false);
		}
		return filterBildCheckBox;
	}

	/**
	 * This method initializes swBildButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getFilterBildButton() {
		if (filterBildButton == null) {
			filterBildButton = new JButton();
			filterBildButton.setText("Gefiltertes Bild");
			filterBildButton.setEnabled(false);
			filterBildButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if(filterBildButton.isEnabled()==true){
						
						setSliderVisbility(false);
						System.out.println("gefiltertes Bild anzeigen"); //FIXME debug
						kartenLayout.show(bildanzeigePanel, FILTERBILD);
						filterBildButton.setEnabled(false);
						orgBildButton.setEnabled(true);	
						
						
						if(houghRaumBildCheckBox.isSelected()==true){
							houghRaumBildButton.setEnabled(true);
						}
						if(houghBildCheckBox.isSelected()==true){
							houghBildButton.setEnabled(true);
						}
					}		
				}
			});
		}
		return filterBildButton;
	}


	/**
	 * This method initializes filterBildCard	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getHoughRaumBildCard() {
		if (houghRaumBildCard == null) {
			houghRaumBildCard = new JPanel();
		}
		return houghRaumBildCard;
	}

	/**
	 * This method initializes filterBildPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getHoughRaumBildPanel() {
		if (houghRaumBildPanel == null) {
			houghRaumBildPanel = new JPanel();
			houghRaumBildPanel.add(getHoughRaumBildCheckBox(), null);
			houghRaumBildPanel.add(getHoughRaumBildButton(), null);
			houghRaumBildButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					System.out.println("Hough - Raum anzeigen");					
				}
			});
		}
		return houghRaumBildPanel;
	}

	/**
	 * This method initializes filterBildCheckBox	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */
	private JCheckBox getHoughRaumBildCheckBox() {
		if (houghRaumBildCheckBox == null) {
			houghRaumBildCheckBox = new JCheckBox();
			houghRaumBildCheckBox.setSelected(false);
			houghRaumBildCheckBox.setEnabled(false);
		}
		return houghRaumBildCheckBox;
	}

	/**
	 * This method initializes filterBildButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getHoughRaumBildButton() {
		if (houghRaumBildButton == null) {
			houghRaumBildButton = new JButton();
			houghRaumBildButton.setText("Hough Raum");
			houghRaumBildButton.setEnabled(false);
			houghRaumBildButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if(houghRaumBildButton.isEnabled()==true){
						schwellWertSlider.setEnabled(false);
						schwellWertLabel.setEnabled(false);
						schwellWertSlider.setPaintLabels(false);						
						kartenLayout.show(bildanzeigePanel, HRBILD);
						houghRaumBildButton.setEnabled(false);
						filterBildButton.setEnabled(true);
						orgBildButton.setEnabled(true);
						if(houghBildCheckBox.isSelected()==true){
							houghBildButton.setEnabled(true);
						}
					}										
				}
			});
		}
		return houghRaumBildButton;
	}


	

	/**
	 * This method initializes sliderPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getSliderPanel() {
		if (sliderPanel == null) {
			schwellWertAnzeigeLabel = new JLabel();
			schwellWertAnzeigeLabel.setVisible(false);
			schwellWertAnzeigeLabel.setEnabled(false);
			schwellWertAnzeigeLabel.setText(String.valueOf(schwellWert));
			schwellWertLabel = new JLabel("Schwellwert", JLabel.CENTER);
			schwellWertLabel.setAlignmentX(Component.CENTER_ALIGNMENT);
			schwellWertLabel.setEnabled(false);
			schwellWertLabel.setVisible(false);
			sliderPanel = new JPanel();
			sliderPanel.add(schwellWertLabel, null);
			sliderPanel.add(getSchwellWertSlider(), null);
			sliderPanel.add(schwellWertAnzeigeLabel, null);
		}
		return sliderPanel;
	}

	
	/**
	 * This method initializes schwellWertSlider	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	private JSlider getSchwellWertSlider() {	    
		if (schwellWertSlider == null) {
			schwellWertSlider = new JSlider(JSlider.HORIZONTAL,SLIDER_MIN, SLIDER_MAX, SLIDER_INIT);
			schwellWertSlider.setVisible(false); 
			schwellWertSlider.setEnabled(true);
			schwellWertSlider.setMajorTickSpacing(10);
			schwellWertSlider.setMinorTickSpacing(5);
			schwellWertSlider.setPaintTicks(true);
			schwellWertSlider.setPaintLabels(true);
			schwellWertSlider.setBorder(BorderFactory.createEmptyBorder(0,0,10,0));
			schwellWertSlider.addChangeListener(this);
			
		}
		return schwellWertSlider;
	}

	

	/**
	 * This method initializes testMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getTestMenu() {
		if (testMenu == null) {
			testMenu = new JMenu();
			testMenu.setText("Leistung");
			testMenu.add(getWertErstellung());
		}
		return testMenu;
	}

	/**
	 * This method initializes wertErstellung	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getWertErstellung() {
		if (wertErstellung == null) {
			wertErstellung = new JMenuItem();
			wertErstellung.setText("Test starten");
			wertErstellung.setToolTipText("erstellt Testwerte und zeigt sie grafisch an");
			wertErstellung.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {					
					powerTestEingabe();
				}
			});
		}
		return wertErstellung;
	}

	/**
	 * This method initializes auswertungMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getAuswertungMenu() {
		if (auswertungMenu == null) {
			auswertungMenu = new JMenu();
			auswertungMenu.setText("Leistungsdaten");
			auswertungMenu.add(getHoughRauMenuItem());
			auswertungMenu.add(getHoughTransformMenuItem());
			auswertungMenu.add(getRatioHoughRaumMenuItem());
			auswertungMenu.add(getRatioTestHoughMenuItem());
			auswertungMenu.add(getRatioGesMenuItem());
		}
		return auswertungMenu;
	}

	/**
	 * This method initializes houghRauMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getHoughRauMenuItem() {
		if (houghRauMenuItem == null) {
			houghRauMenuItem = new JMenuItem();
			houghRauMenuItem.setText("Power-Test: Hough-Raum");			
			houghRauMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					powerTest(pfad+"ressources/ges_powerTestHoughRaum.txt"); 
				}
				
			});
		}
		return houghRauMenuItem;
	}

	/**
	 * This method initializes houghTransformMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getHoughTransformMenuItem() {
		if (houghTransformMenuItem == null) {
			houghTransformMenuItem = new JMenuItem();
			houghTransformMenuItem.setText("Power-Test: Hough-Transformation");
			houghTransformMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					powerTest(pfad+"ressources/ges_powerTestHoughTrans.txt");
				}
			});
		}
		return houghTransformMenuItem;
	}

	/**
	 * This method initializes ratioTestHoughMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getRatioTestHoughMenuItem() {
		if (ratioTestHoughMenuItem == null) {
			ratioTestHoughMenuItem = new JMenuItem();
			ratioTestHoughMenuItem.setText("Ratio-Test: Hough-Berechnung");
			ratioTestHoughMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					powerTest(pfad+"ressources/ges_ratioTestHough.txt");
				}
			});
		}
		return ratioTestHoughMenuItem;
	}

	/**
	 * This method initializes ratioHoughRaumMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getRatioHoughRaumMenuItem() {
		if (ratioHoughRaumMenuItem == null) {
			ratioHoughRaumMenuItem = new JMenuItem();
			ratioHoughRaumMenuItem.setText("Ratio-Test: Hough-Raum");
			ratioHoughRaumMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					powerTest(pfad+"ressources/ges_ratioTestHoughRaum.txt");
				}
			});
		}
		return ratioHoughRaumMenuItem;
	}

	/**
	 * This method initializes ratioGesMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getRatioGesMenuItem() {
		if (ratioGesMenuItem == null) {
			ratioGesMenuItem = new JMenuItem();
			ratioGesMenuItem.setText("Ratio-Test: ganze Hough Transformation");
			ratioGesMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					powerTest(pfad+"ressources/ges_ratioTestHoughTrans.txt");
				}
			});
		}
		return ratioGesMenuItem;
	}

	

	public static void main( String[] args) {
		try 
		{   
			//UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		    UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());		    
		} 
		catch (Exception exc) {  System.err.println("Fehler beim Laden des Feel & Look: " + exc);}
		
		/*HoughTransformationGUI application = new HoughTransformationGUI();
		application.show();
		*/
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new HoughTransformationGUI().show();
			}
		});
	}
	
	/**
	 * @param args
	 */
/*	public static void main(final String[] args) {
		try 
		{   
			//UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		    UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());		    
		} 
		catch (Exception exc) {  System.err.println("Fehler beim Laden des Feel & Look: " + exc);}
		
		/*HoughTransformationGUI application = new HoughTransformationGUI();
		application.show();
		*/
/*		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new HoughTransformationGUI().show();
			}
		});
	}*/

	/**
	 * This is the default constructor
	 */
	public HoughTransformationGUI() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.setJMenuBar(getJJMenuBar());
		this.setSize(570, 200);
		this.setContentPane(getJContentPane());
		
		setWindowTitle(0);		
	}
	
	/**
	 * setzt den Fenstertitel 
	 * 
	 * @param 0 Hough - Transformation
	 * @param 1 Bitte warten, Berechnung luft...
	 * @param 2 Berechnung beendet
	 * @param -1 Fehler 
	 */
	private void setWindowTitle(int i){
		if(i == 0)	this.setTitle("Hough - Transformation");
		if(i == 1)  this.setTitle("Bitte warten Berechnung luft...");
		if(i == 2)  this.setTitle("Berechnung beendet");
		if(i == -1) this.setTitle("Fehler !");
	}
	
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BoxLayout(getJContentPane(), BoxLayout.Y_AXIS));
			jContentPane.add(getMenuePanel(), null);
			jContentPane.add(getBildanzeigePanel(), null);
			jContentPane.add(getSliderPanel(), null);
		}
		return jContentPane;
	}

	private void setSliderVisbility(boolean b ){
		if(b==true){
			schwellWertSlider.setEnabled(true);
			schwellWertAnzeigeLabel.setEnabled(true);
			schwellWertLabel.setEnabled(true);
			schwellWertSlider.setVisible(true);
			schwellWertAnzeigeLabel.setVisible(true);
			schwellWertLabel.setVisible(true);
		}
		else{
			schwellWertSlider.setVisible(false);
			schwellWertAnzeigeLabel.setVisible(false);
			schwellWertLabel.setVisible(false);
		}
	}
	
	
	
	
	
	/*********************************************************************************************/
	
	
	
	
	
	
	
	
	/**
	 * This method initializes jJMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */
	private JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new JMenuBar();
			jJMenuBar.add(getFileMenu());
			jJMenuBar.add(getEditMenu());
			jJMenuBar.add(getTestMenu());
			jJMenuBar.add(getHelpMenu());
		}
		return jJMenuBar;
	}

	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getFileMenu() {
		if (fileMenu == null) {
			fileMenu = new JMenu();
			fileMenu.setText("Datei");
			fileMenu.add(getOpenMenuItem());
			fileMenu.add(getExitMenuItem());
		}
		return fileMenu;
	}

	/**
	 * This method initializes openMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getOpenMenuItem() {
		if (openMenuItem == null) {
			openMenuItem = new JMenuItem();
			openMenuItem.setText("ffnen");
			openMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,
					Event.CTRL_MASK, true));
			//TODO speichern aufruf beenden
			/*openMenuItem.setActionCommand("save");
			openMenuItem.addActionListener(this);
		*/	openMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed( ActionEvent e )
				{	
					if(dateiAuswahl==null){
						dateiAuswahl = new JFileChooser();
						dateiAuswahl.setFocusable(true);
						dateiAuswahl.isFocusOwner();
						
						dateiAuswahl.setFileFilter( new FileFilter(){
							public boolean accept(File f)
							{
								return f.isDirectory() || f.getName().toLowerCase().endsWith(".jpg")
								|| f.getName().toLowerCase().endsWith(".gif")
								|| f.getName().toLowerCase().endsWith(".png")
								|| f.getName().toLowerCase().endsWith(".bmp");
							}
							
							public String getDescription(){	return "*.jpg;*.gif;*.png;*.bmp";}
							} 
						);
					}
					
						
					int retval = dateiAuswahl.showOpenDialog(null);
		    		if(retval != JFileChooser.CANCEL_OPTION) 
		    		{		
		    			
		    			if(alleBilder[0]!=null)initializeAll();	
		    			File file = dateiAuswahl.getSelectedFile();
		    			
						try {
							
								if(file.getName().endsWith(".tmp"))powerTest(file.getName());
								else if(file.getName().endsWith(".jpg") || file.getName().endsWith(".gif") || file.getName().endsWith(".png") || file.getName().endsWith(".bmp")){
									alleBilder[0] = ImageIO.read(file);
									orgBildComponent = new ImageComponent(alleBilder[0]);
									
									kartenLayout = (CardLayout)(bildanzeigePanel.getLayout());
									getOrgBildCard();
									orgBildCard.add(orgBildComponent);
									bildanzeigePanel.add(orgBildCard, ORIGINALBILD);
									kartenLayout.show(bildanzeigePanel, ORIGINALBILD);
									
									menuePanel.setVisible(true);
									houghMenuItem.setEnabled(true);
									nextMenuItem.setEnabled(true);
									
									orgBildCheckBox.setSelected(true);						
									setSliderVisbility(false);
									
									pack();
								}
								else{											
									JOptionPane.showConfirmDialog(null, 
											"Dieser Dateityp wird nicht untersttzt!", 
											"Fehler!",
											JOptionPane.CLOSED_OPTION,
											JOptionPane.ERROR_MESSAGE);	
								}								
						}	
						catch (IOException e1) {e1.printStackTrace();}							
					}					
				}

			});
			
		}
		return openMenuItem;
	}
	

	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getEditMenu() {
		if (editMenu == null) {
			editMenu = new JMenu();
			editMenu.setText("Schritte");
			editMenu.add(getNextMenuItem());
			editMenu.add(getHoughMenuItem());}
		return editMenu;
	}

	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */
	private JMenu getHelpMenu() {
		if (helpMenu == null) {
			helpMenu = new JMenu();
			helpMenu.setText("Info");
			helpMenu.add(getAboutMenuItem());
			helpMenu.add(getAuswertungMenu());
		}
		return helpMenu;
	}

	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getExitMenuItem() {
		if (exitMenuItem == null) {
			exitMenuItem = new JMenuItem();
			exitMenuItem.setText("Beenden");
			exitMenuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					initializeAll();
					File fd = new File("powertestHR.tmp");
					fd.delete();
					
					File fd2 = new File("powertestHough.tmp");
					fd2.delete();
					System.gc();
					System.exit(0);					
				}
			});
		}
		return exitMenuItem;
	}

	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getAboutMenuItem() {
		if (aboutMenuItem == null) {
			aboutMenuItem = new JMenuItem();
			aboutMenuItem.setText("ber..");
			aboutMenuItem.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					JOptionPane.showConfirmDialog(null, 
							"Dieses Programm findet Linien in einem Bild. \n Es ist ein Projekt fr das Fach Algorithmische Anwendungen der Studenten V. Schaefer und A. Zipser", 
							"Info",
							JOptionPane.CLOSED_OPTION,
							JOptionPane.INFORMATION_MESSAGE);	
				}
			});
		}
		return aboutMenuItem;
	}
	
	/**
	 * berechnet das Filterbild
	 */
	private void setFilterBild(){
		setWindowTitle(1);
		IBildBearbeitung pic = new BerechnungBildFilter(alleBilder[0]); 
		alleBilder[1] = pic.getCalculatedImage();						
		filterBildComponent = new ImageComponent(alleBilder[1]);
		
		getFilterBildCard();
		filterBildCard.add(filterBildComponent);
		bildanzeigePanel.add(filterBildCard, FILTERBILD);	
		kartenLayout.show(bildanzeigePanel, FILTERBILD);
		pack();
		
		setWindowTitle(0);
		
		setSliderVisbility(false);
		filterBildCheckBox.setSelected(true);
		orgBildButton.setEnabled(true);
	}

	/**
	 * berechnet das Hough Raum Bild
	 */
	private void setHoughRaumBild(){
		setWindowTitle(1);
		IBildBearbeitung pic = new BerechnungHoughRaum(alleBilder[1],alleBilder[1].getWidth(new MyImageObserver()),alleBilder[1].getHeight(new MyImageObserver()));
		alleBilder[2] = pic.getCalculatedImage();	
		//houghRaumComponent = new ImageComponent(alleBilder[2]);
		houghRaumComponent = new ImageComponent(pic.getMoreContrast(alleBilder[2], alleBilder[2].getWidth(new MyImageObserver()),alleBilder[2].getHeight(new MyImageObserver())));
		getHoughRaumBildCard();
		houghRaumBildCard.add(houghRaumComponent);
		bildanzeigePanel.add(houghRaumBildCard, HRBILD);
		kartenLayout.show(bildanzeigePanel,HRBILD);
		pack();
		
		orgBildButton.setEnabled(true);
		filterBildButton.setEnabled(true);
		houghRaumBildCheckBox.setSelected(true);
		
		setWindowTitle(0);
		setSliderVisbility(false);
	}
	
	
	/**
	 *  berecnet das Hough Bild
	 */
	private void setHoughBild(){
		setWindowTitle(1);
		IBildBearbeitung pic = new BerechnungHough(	alleBilder[0],
				   									alleBilder[0].getWidth(new MyImageObserver()),
				   									alleBilder[0].getHeight(new MyImageObserver()),
				   									alleBilder[2],
				   									alleBilder[2].getWidth(new MyImageObserver()),
				   									alleBilder[2].getHeight(new MyImageObserver()),
				   									schwellWert
				   									
				   								);
		alleBilder[3]=pic.getCalculatedImage();						
		houghBildComponent = new ImageComponent(alleBilder[3]);
		getHoughBildCard();
		houghBildCard.add(houghBildComponent);
		bildanzeigePanel.add(houghBildCard,HOUGHBILD);
		kartenLayout.show(bildanzeigePanel, HOUGHBILD);
		
		
		setSliderVisbility(true);
		
		pack();
		houghRaumBildButton.setEnabled(true);
		houghBildCheckBox.setSelected(true);
		orgBildButton.setEnabled(true);
		filterBildButton.setEnabled(true);
		
		setWindowTitle(0);
		
	}
	
	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getNextMenuItem() {
		if (nextMenuItem == null) {
			nextMenuItem = new JMenuItem();
			nextMenuItem.setText("nchster");
			nextMenuItem.setEnabled(false);
			nextMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,
					Event.CTRL_MASK, true));
			nextMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					//filterbild erstellen
					if(alleBilder[0]!=null && alleBilder[1]==null && alleBilder[2]==null && alleBilder[3]==null){ //filterbild
												
						setFilterBild();											
						houghMenuItem.setEnabled(false);						        				        
				     }
					//hough-raum-bild erstellen
					else if(alleBilder[0]!=null && alleBilder[1]!=null && alleBilder[2]==null && alleBilder[3]==null){//haoughraum
						
						setHoughRaumBild();											
					}
					//hough-bild-berechnen
					else if(alleBilder[0]!=null && alleBilder[1]!=null && alleBilder[2]!=null && alleBilder[3]==null){//Hough
						
						setHoughBild();
						
						nextMenuItem.setEnabled(false);						
					}
				}
			});
		}
		return nextMenuItem;
	}


	/**
	 * This method initializes houghMenuItem	
	 * 	durekte Houghtransformation, nachdem man das erste bild geladen hat 
	 * @return javax.swing.JMenuItem	
	 */
	private JMenuItem getHoughMenuItem() {
		if (houghMenuItem == null) {
			houghMenuItem = new JMenuItem();
			houghMenuItem.setText("Houghtransformation");
			houghMenuItem.setEnabled(false);
			houghMenuItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H,
					Event.CTRL_MASK, true));
			houghMenuItem.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					nextMenuItem.setEnabled(false);
					
					if(alleBilder[0]!=null && alleBilder[1]==null && alleBilder[2]==null && alleBilder[3]==null){ //originalbild geladen
					
						setFilterBild();
						setHoughRaumBild();						
						setHoughBild();																		
												
						nextMenuItem.setEnabled(false);
						houghMenuItem.setEnabled(false);
						kartenLayout.show(bildanzeigePanel, HOUGHBILD);
						pack();						
					}
				}
			});		
		}
		return houghMenuItem;
	}

	

	//TODO speichern implementieren, bzw. vorhandenen Code anpassen
	/**
     * actionListener, reagiert auf datei-ffnen
     * @throws IOException
 	 */
    public void actionPerformed(ActionEvent e)  
    {		
    	if(e.getActionCommand() == "save") 
    	{     		
    		int retval = dateiAuswahl.showSaveDialog(this);
    		if(retval == JFileChooser.CANCEL_OPTION) 
    		{
    			System.out.println("cancel"); 
    		}
			else if (retval == JFileChooser.APPROVE_OPTION) 
			{
				int n = 0;				
				try
				{					
						File dieDatei = dateiAuswahl.getSelectedFile();
						System.out.println(dieDatei.canWrite());
						if(dieDatei.canWrite())
						{
							n = JOptionPane.showConfirmDialog(
								    this,
								    "Datei schon vorhanden ! \nSoll die Datei berschrieben werden ?",
								    "Datei schon vorhanden !",
								    JOptionPane.YES_NO_OPTION);
							if(n == 0)
							{								
								ImageIO.write((BufferedImage)alleBilder[1],"jpg",ImageIO.createImageOutputStream(new File(dieDatei.getName())));
								n=3;
							}
						}
						else if(!dieDatei.canWrite())
						{
							System.out.println(((String)dieDatei.getName()).substring(((String)dieDatei.getName()).indexOf(".")));
							System.out.println("datei: "+dieDatei.getName());
							ImageIO.write((BufferedImage)alleBilder[1],((String)dieDatei.getName()).substring(((String)dieDatei.getName()).indexOf(".")+1),ImageIO.createImageOutputStream(new File("Test.jpg"))); //((String)dieDatei.getName()).substring((0,(String)dieDatei.getName()).indexOf(".")-1))));
						}					
				}
				catch(IOException ee){ System.err.println(ee); }			
			}  
			else System.out.println("fehler");     		
    	}    	
    }

    void initializeAll(){
    	if(alleBilder[0]!=null)kartenLayout.removeLayoutComponent(orgBildCard);
		if(alleBilder[1]!=null)kartenLayout.removeLayoutComponent(filterBildCard);						
		if(alleBilder[2]!=null)kartenLayout.removeLayoutComponent(houghRaumBildCard);
		if(alleBilder[3]!=null)kartenLayout.removeLayoutComponent(houghBildCard);
		
		alleBilder[0]=null;
		alleBilder[1]=null;
		alleBilder[2]=null;
		alleBilder[3]=null;
		
		
		orgBildCard = null;
		orgBildButton.setEnabled(false);
		orgBildCheckBox.setSelected(false);
		filterBildCard = null;
		filterBildButton.setEnabled(false);
		filterBildCheckBox.setSelected(false);
		houghRaumBildCard = null;
		houghRaumBildButton.setEnabled(false);
		houghRaumBildCheckBox.setSelected(false);
		houghBildCard = null;
		houghBildButton.setEnabled(false);
		houghBildCheckBox.setSelected(false);
		bildanzeigePanel.removeAll();
		schwellWertSlider.setEnabled(false);
		schwellWertSlider.setVisible(false);
		schwellWertSlider.setPaintLabels(false);
		schwellWertLabel.setEnabled(false);
		schwellWertLabel.setVisible(false);
		schwellWertAnzeigeLabel.setVisible(false);
		schwellWertAnzeigeLabel.setEnabled(false);
		
		System.gc();
    }

    /**
     * erzeugt ein neues ptPlot objekt, dass die Auswertung der Test-Werte anzeigt 
     * @param name String (Titel des Plots)
     */
    public void powerTest(String name){
    	TestPlot plotLiveDemo = new TestPlot(name);
    	plotLiveDemo.addWindowListener(new WindowAdapter() {
    		public void windowClosing(WindowEvent e) {
    			System.out.println("schliessen");
    		}
    	});    	
    }
    
    /**
     * Eingabe-Maske, um Testwerte fr die Leistungs-Auswertungs einzugeben 
     *
     */
    public void powerTestEingabe(){
    	FlowLayout flowLayout = new FlowLayout();
		flowLayout.setAlignment(java.awt.FlowLayout.LEFT);
		
		JLabel jl = new JLabel();
		jl.setText("Bitte Werte fr die Berechnung eingeben: Bildgrsse und Schritte");
				
    	JPanel textPanel = new JPanel();
    	textPanel.setLayout(flowLayout);
		textPanel.add(jl,null);
				
		JLabel vonLabel= new JLabel();
		JLabel bisLabel= new JLabel();
		JLabel schritteLabel= new JLabel();
		vonLabel.setText("von");
		bisLabel.setText("bis");
		schritteLabel.setText("Schritte");
		
		JPanel textLabelPanel = new JPanel();
		textLabelPanel.setLayout(new BoxLayout(textLabelPanel, BoxLayout.Y_AXIS));
		textLabelPanel.add(vonLabel, null);
		textLabelPanel.add(bisLabel, null);
		textLabelPanel.add(schritteLabel, null);
		
		final JTextField vonField = new JTextField();
		final JTextField bisField = new JTextField();
		final JTextField schrittField = new JTextField();
		vonField.setPreferredSize(new java.awt.Dimension(100,20));
		bisField.setPreferredSize(new java.awt.Dimension(100,20));
		schrittField.setPreferredSize(new java.awt.Dimension(100,20));
		
		JPanel eingPanel= new JPanel();
		eingPanel.setLayout(new BoxLayout(eingPanel, BoxLayout.Y_AXIS));
		eingPanel.add(vonField, null);
		eingPanel.add(bisField, null);
		eingPanel.add(schrittField, null);
		
		JPanel eingabePanel = new JPanel();
		eingabePanel.setLayout(new FlowLayout());
		eingabePanel.add(textLabelPanel, null);
		eingabePanel.add(eingPanel, null);
		
		JButton start = new JButton("Start");
		start.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.out.println("start");
				
				try{
					if(vonField.getText().equals("") || bisField.getText().equals("")|| schrittField.getText().equals("") ){
						JOptionPane.showConfirmDialog(null, 
								"Kein oder falsche Werte eingegeben !", 
								"Fehler",
								JOptionPane.CLOSED_OPTION,
								JOptionPane.ERROR_MESSAGE);	
					}	
					int v = Integer.valueOf(vonField.getText());
					int b = Integer.valueOf(bisField.getText());
					int s = Integer.valueOf(schrittField.getText());
					
					powerTestWerte(vonField.getText(), bisField.getText(),schrittField.getText());
					
				}
				catch(NumberFormatException ee){
					JOptionPane.showConfirmDialog(null, 
							"Kein oder falsche Werte eingegeben !", 
							"Fehler",
							JOptionPane.CLOSED_OPTION,
							JOptionPane.ERROR_MESSAGE);	
				}
			}
		});    
		
		JButton cancel = new JButton("Abbrechen");
		cancel.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.out.println("cancel");	
				fensterl.dispose();							
			}
		});
		
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new FlowLayout());
		buttonPanel.add(start, null);
		buttonPanel.add(cancel, null);
		
		JPanel allesPane = new JPanel();
		allesPane.setLayout(new BoxLayout(allesPane, BoxLayout.Y_AXIS));
		allesPane.add(textPanel, null);
		allesPane.add(eingabePanel, null);
		allesPane.add(buttonPanel, null);		
		
		fensterl.setSize(300, 200);
		fensterl.setResizable(false);
		fensterl.setLocation(300,300);
		fensterl.setContentPane(allesPane);
		fensterl.setTitle("Testwert-Eingabe");
		fensterl.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		fensterl.pack();
		fensterl.show();
    }
    
    /**
     * zhlt die peak-ausschlge 
     * @param Img
     */
    public static void Peaksauswertung(Image Img)
	{
		int PeakValues[] = new int[200];
		int Bildbreite=Img.getWidth(new MyImageObserver());
		int Bildhoehe=Img.getHeight(new MyImageObserver());
		int[] ArrayBild = new int[Bildbreite*Bildhoehe];		
		PixelGrabber pg = new PixelGrabber(Img, 0, 0, Bildbreite, Bildhoehe, ArrayBild, 0, Bildbreite);
	    try
	    {
	            pg.grabPixels();
	    }
	    catch (InterruptedException e)
	    {
	       System.err.println("interrupted waiting for pixels!");
	    }		
	    for(int i=0;i<(Bildbreite*Bildhoehe);i++)
	    {
	      if((ArrayBild[i] & 0x00FFFFFF) < 100 )
	      {
	    	  PeakValues[(ArrayBild[i] & 0x00FFFFFF)]=PeakValues[(ArrayBild[i] & 0x00FFFFFF)]+1;
	      }
	    }
	    try
	    {
	      FileWriter fw = new FileWriter(new File("Peaks.txt"),true);
	      BufferedWriter bw = new BufferedWriter(fw);
	      for(int i=0;i<PeakValues.length;i++)
	      {
	    	  String str = (new Integer(Bildbreite*Bildhoehe)).toString();
	    	  str=str.concat(new String(";"));
	    	  str=str.concat(new String((new Integer(i)).toString()));
	    	  str=str.concat(new String(";"));
	    	  str=str.concat(new String((new Integer(PeakValues[i])).toString()));
	    	  
	    	  bw.write(str);
	    	  bw.newLine();
	      }
	      bw.close();
	      fw.close();
	    }
	    catch(IOException e)
	    {
	    	e.printStackTrace();
	    }
	    
	}
    
    /**
     * Testklasse, welche ein Bild generiert, und dann die die Analyse-Werte erzeugt. Die Parameter werden bergeben
     * @param _von
     * @param _bis
     * @param _schritte
     */
    public void powerTestWerte(String _von,	String _bis, String _schritte){   
    	
    	System.out.println("POWERTEST - MODUS\nSchrittweite: "+_schritte+"\nBildgrsse: von "+_von+" bis "+_bis);
    	
    	JFrame jf = new JFrame("Testverfahren bei Hough Transformation");
    	jf.getContentPane().setLayout(new BorderLayout());		
		jf.getContentPane().add(new JLabel("Hough Transformation"),BorderLayout.NORTH);
    	
    	int von = Integer.parseInt(_von);
    	int bis = Integer.parseInt(_bis);
    	int schritte = Integer.parseInt(_schritte);    			
		
	//	JLabel BildInfos = new JLabel ("Bild x wind bearbeitet");		
	//	String InfoTxt = "Derzeitige Bildgroesse:";
		
		File fd = new File("powertestHR.tmp");
		fd.delete();
		
		File fd2 = new File("powertestHough.tmp");
		fd2.delete();
		
		int Bildbreite=0;
		int Bildhoehe=0;
		
		System.out.println("Berechnung beginnt");
		for(int Bildgroesse = von; Bildgroesse < bis; Bildgroesse = Bildgroesse + schritte)
		{		
			System.out.println(".");
			Bildbreite = Bildgroesse;
			Bildhoehe=Bildgroesse;
			
			int[] genBild = new int[Bildbreite*Bildhoehe];
			
			for(int zaehler=0;zaehler<Bildbreite*Bildhoehe;zaehler++)
			{
				genBild[zaehler]=0xFF000000;
				int wert=(zaehler % 2)*0xFFFFFF;
				genBild[zaehler] = (genBild[zaehler] | wert);
			}		
			
			Image Img = Toolkit.getDefaultToolkit().createImage(new MemoryImageSource(Bildbreite, Bildhoehe, genBild, 0, Bildbreite) ); 
				
			BerechnungHoughRaum HRaum = new BerechnungHoughRaum(Img,Bildbreite,Bildhoehe);						
			Image iHRaum = HRaum.getCalculatedImage();
			//todo
			//Peaksauswertung(iHRaum);
		
			BerechnungHough bHough = new BerechnungHough(Img,Bildbreite,Bildhoehe,iHRaum,iHRaum.getWidth(new MyImageObserver()),iHRaum.getHeight(new MyImageObserver()),0.8);
			
		}    	
		System.out.println("Berechnung abgeschlossen");
		System.out.println("Powertest beendet");
		JOptionPane.showConfirmDialog(null, 
				"Messwert-Dateien wurden erzeugt ", 
				"Info",
				JOptionPane.CLOSED_OPTION,
				JOptionPane.INFORMATION_MESSAGE);
		fensterl.dispose();
		powerTest("powertestHR.tmp");
		powerTest("powertestHough.tmp");
		
    }
    
    /**
     * Listener fr den Schwell-Werte -Slider
     */
	public void stateChanged(ChangeEvent e) {
		// TODO slider zu ende bringen
		JSlider source = (JSlider)e.getSource();

		schwellWertAnzeigeLabel.setText(String.valueOf(schwellWertSlider.getValue()));
        
		if (!source.getValueIsAdjusting()) {
        	//TODO debug
			System.out.println("Slider-Wert gendert");
        	System.out.println("neuer  Slider-Wert: " +schwellWertSlider.getValue());
        	
        	schwellWert = Double.valueOf(schwellWertSlider.getValue())/100;
        	schwellWertAnzeigeLabel.setText(String.valueOf(schwellWertSlider.getValue()));
        	
        	//TODO debug:
        	System.out.println("schwellwert: "+schwellWert);
        	
        	alleBilder[3]=null;  
        	houghBildCard.remove(houghBildComponent);
        	houghBildComponent = null;
        	
        	IBildBearbeitung pic = new BerechnungHough(	alleBilder[0],
						alleBilder[0].getWidth(new MyImageObserver()),
						alleBilder[0].getHeight(new MyImageObserver()),
						alleBilder[2],
						alleBilder[2].getWidth(new MyImageObserver()),
						alleBilder[2].getHeight(new MyImageObserver()),
						schwellWert						
					);
        	
			alleBilder[3]=pic.getCalculatedImage();
			
			houghBildComponent = new ImageComponent(alleBilder[3]);
			getHoughBildCard();
			houghBildCard.add(houghBildComponent);
			bildanzeigePanel.add(houghBildCard,HOUGHBILD);
			kartenLayout.show(bildanzeigePanel, HOUGHBILD);
			
			pack();
			
        } 		
	}
}


