
package Transformation.Hough;

import java.awt.Image;


/** 
 * Schnittstelle zu den einzelnen Bildbearbeitungs-Schritten
 * --> schwarz-weiss
 * --> filter
 * --> Hough-Transformation
 * Jede Klasse die unsere Bildbearbeitung benutzt, hat eine
 * Methode getCalculateImage implementiert. Damit ist dem
 * User Interface egal, wie die Klassen diese Sachen implementieren,
 * hauptsache es kommt damit parat. 
 *
 */
public interface IBildBearbeitung {

/**
 * liefert ein Image von der jeweiligen klasse zurck
 * @return Image
 */
	public Image getCalculatedImage();
	/**
	 * Schrft den Kontrast.
	 * @param source
	 * @param width
	 * @param height
	 * @return
	 */
	public Image getMoreContrast(Image source,int width,int height);
}
